/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package registroUsuario.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import org.json.JSONArray;
import org.json.JSONObject;
import registroUsuario.beans.CursosBean;
import registroUsuario.dao.CursoDao;

/**
 *
 * @author sistem17user
 */
public class CursoMysqlDao implements CursoDao {

    @Override
    public JSONArray listarNivel() throws Exception {
        ArrayList<CursosBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select * from mdl_course_categories "
                + " where parent = 0 "
                + " and id not in (2,4) ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            while (rs.next()) {
                CursosBean c = new CursosBean();
                c.setCodNivel(rs.getString(1));
                c.setDesNivel(rs.getString(2));
                lista.add(c);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public JSONArray listarGrado(int parent) throws Exception {
        ArrayList<CursosBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = "";
        try {
            if (parent != 3) {
                query = " select id, name from mdl_course_categories "
                        + " where parent = ? ";
            } else if (parent == 3) {
                query = " select id, name from mdl_course_categories "
                        + " where parent = ? "
                        + "or id = 3";
            }
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            pst.setInt(1, parent);
            rs = pst.executeQuery();
            while (rs.next()) {
                CursosBean g = new CursosBean();
                g.setCodGrado(rs.getString(1));
                g.setDesGrado(rs.getString(2));
                lista.add(g);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public JSONArray listarCursos(int parent) throws Exception {
        ArrayList<CursosBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select id, fullname from mdl_course "
                + " where category =" + parent + " ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            while (rs.next()) {
                CursosBean g = new CursosBean();
                g.setCodCurso(rs.getString(1));
                g.setDesCurso(rs.getString(2));
                lista.add(g);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public int asignarCurso(int enrol, String userid, int cboCurso, String cboGrado) throws Exception {
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        int rs = 0;
        String query = "";
        try {
            if (cboCurso == 0) {
                
                query = " insert into mdl_user_enrolments (enrolid, userid) "
                        + " select me.id, " + userid + " from mdl_enrol as me "
                        + " inner join mdl_course as mc "
                        + " on me.courseid = mc.id "
                        + " where enrol = 'manual' "
                        + " and mc.category = " + cboGrado + ""
                        + " and me.id not in (SELECT mdu.enrolid from mdl_user_enrolments mdu "
                        + "where userid = '" + userid + "')";
            } else {
                
                query = " insert ignore into mdl_user_enrolments (enrolid, userid) "
                        + " values (" + enrol + ", " + userid + ") ";
            }

            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return rs;
    }

    @Override
    public JSONObject listarCursos(String id, int vstart, int vlength, String draw) throws Exception {
        String base = "moodle";
        JSONObject jsonReturn = new JSONObject();
        JSONArray jsonArray = new JSONArray();
        Connection cn = null;
        ResultSet rs = null;
        PreparedStatement ps = null;
        String query = " ";
        System.out.println("id " + id);
        String busqueda = " where mu.id = " + id + " ";
        query = " select ifnull(me.id,''), ifnull(mcc.name, ''), ifnull(mc.fullname,'') from mdl_user as mu "
                + " inner join mdl_user_enrolments as me "
                + " on mu.id = me.userid "
                + " inner join mdl_enrol as mr "
                + " on mr.id = me.enrolid "
                + " inner join mdl_course as mc "
                + " on mr.courseid = mc.id "
                + " inner join mdl_course_categories mcc "
                + " on mcc.id = mc.category "
                + " " + busqueda + " "
                + " order by mc.fullname "
                + " LIMIT " + vstart + "," + vlength + "";
        try {
            cn = MysqlDAOFactory.obtenerConexion(base);
            ps = cn.prepareStatement(query);
            rs = ps.executeQuery();
            while (rs.next()) {
                JSONObject obj = new JSONObject();
                obj.put("idCursos", rs.getString(1));
                obj.put("categoria", rs.getString(2));
                obj.put("curso", rs.getString(3));
                jsonArray.put(obj);
            }
            int filasTotales;
            String sql2 = " select count(*) as filasTotales from mdl_user as mu "
                    + " inner join mdl_user_enrolments as me "
                    + " on mu.id = me.userid "
                    + " inner join mdl_enrol as mr "
                    + " on mr.id = me.enrolid "
                    + " inner join mdl_course as mc "
                    + " on mr.courseid = mc.id "
                    + " inner join mdl_course_categories mcc "
                    + " on mcc.id = mc.category "
                    + " " + busqueda + " ";
            PreparedStatement ps2 = cn.prepareStatement(sql2);
            ResultSet rs2 = ps2.executeQuery();
            rs2.next();
            filasTotales = rs2.getInt("filasTotales");
            jsonReturn.put("data", jsonArray);
            jsonReturn.put("recordsTotal", filasTotales);
            jsonReturn.put("recordsFiltered", filasTotales);
            jsonReturn.put("draw", draw);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            cn.close();
            rs.close();
            ps.close();
        }
        return jsonReturn;
    }

    @Override
    public int obtenerEnrol(int codCurso) throws Exception {
        int enrol = 0;
        String bd = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        String query = "";
        ResultSet rs = null;
        try {
            query = " select id as idenrol from mdl_enrol "
                    + " where enrol = 'manual' "
                    + " and courseid = " + codCurso + " ";
            con = MysqlDAOFactory.obtenerConexion(bd);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            rs.next();
            enrol = Integer.parseInt(rs.getString("idenrol"));
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return enrol;
    }

    @Override
    public int eliminarCursos(String codCurso) throws Exception {
        int rs = 0;
        Connection con = null;
        PreparedStatement pst = null;
        String bd = "moodle";
        String query = " ";
        try {
            query = " delete from mdl_user_enrolments "
                    + " where id in  (" + codCurso + ") ";
            con = MysqlDAOFactory.obtenerConexion(bd);
            pst = con.prepareStatement(query);
            rs = pst.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return rs;
    }
}


