/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package registroUsuario.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.json.JSONArray;
import org.json.JSONObject;
import registroUsuario.beans.UsuarioBean;
import registroUsuario.dao.UsuarioDao;

/**
 *
 * @author sistem17user
 */
public class UsuarioMysqlDao implements UsuarioDao {

    @Override
    public int registrarUsuario(UsuarioBean u) throws Exception {
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        int rs = 0;
        String query = " insert into mdl_user(auth, confirmed, mnethostid, username, "
                + " password, idnumber, firstname, "
                + " lastname, email, lang, timezone, "
                + " apePat, apeMat, country, codNiv, "
                + " desNiv, codGra, desGra, codSede, "
                + " desSede, conTemp)"
                + " values(?, 1, 1, ?, 'not cached', ?, ?, concat(?, ' ' ,?) , ?, 'es_mx', 'America/Lima', ?, ?, 'PE',"
                + " '" + u.getCodNivel() + "', '" + u.getDesNivel() + "', '" + u.getCodGrado() + "', '" + u.getDesGrado() + "',"
                + " '" + u.getCodSede() + "', '" + u.getDesSede() + "', '" + u.getContraseñaUsuario() + "') ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            pst.setString(1, u.getDesTipo());
            pst.setString(2, u.getCorreoUsuario());
            pst.setString(3, u.getDniUsuario());
            String dni = u.getDniUsuario();
            pst.setString(4, u.getNombreUsuario());
            pst.setString(5, u.getApepatUsuario());
            pst.setString(6, u.getApematUsuario());
            pst.setString(7, u.getCorreoUsuario());
            pst.setString(8, u.getApepatUsuario());
            pst.setString(9, u.getApematUsuario());
            rs = pst.executeUpdate();

            String query2 = " select id from mdl_user "
                    + " where idnumber = ? ";
            PreparedStatement pst2 = null;
            pst2 = con.prepareStatement(query2);
            pst2.setString(1, dni);
            ResultSet rs2 = pst2.executeQuery();
            rs2.next();
            String id = rs2.getString(1);

            String query3 = " insert into mdl_user_info_data(userid, fieldid, data) "
                    + " values (" + id + ",4 , '" + u.getRolUsuario() + "')";
            PreparedStatement pst3 = null;
            pst3 = con.prepareStatement(query3);
            pst3.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return rs;
    }

    @Override
    public JSONArray listarSede() throws Exception {
        ArrayList<UsuarioBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select sede from usuario ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            while (rs.next()) {
                UsuarioBean s = new UsuarioBean();
                s.setCodSede(rs.getString(1));
                s.setDesSede(rs.getString(1));
                lista.add(s);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public JSONArray listarNivel() throws Exception {
        ArrayList<UsuarioBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select * from mdl_course_categories "
                + " where parent = 0 "
                + " and id not in (2,4) ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            while (rs.next()) {
                UsuarioBean n = new UsuarioBean();
                n.setCodNivel(rs.getString(1));
                n.setDesNivel(rs.getString(2));
                lista.add(n);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public JSONArray listarGrado(int parent) throws Exception {
        ArrayList<UsuarioBean> lista = new ArrayList<>();
        JSONArray array = null;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select id, name from mdl_course_categories "
                + " where parent = ? ";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            pst.setInt(1, parent);
            rs = pst.executeQuery();
            while (rs.next()) {
                UsuarioBean g = new UsuarioBean();
                g.setCodGrado(rs.getString(1));
                g.setDesGrado(rs.getString(2));
                lista.add(g);
            }
            array = new JSONArray(lista);
        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            con.close();
            pst.close();
        }
        return array;
    }

    @Override
    public JSONObject listarUsuario(String tipoBusqueda, String filtro, int vstart, int vlength, String draw) throws Exception {
        String base = "moodle";
        JSONObject jsonReturn = new JSONObject();
        JSONArray jsonArray = new JSONArray();
        Connection cn = null;
        ResultSet rs = null;
        PreparedStatement ps = null;
        String query = " ";
        String busqueda = " ";
        switch (tipoBusqueda) {
            case "0":
                busqueda = " ";
                break;
            case "1":
                busqueda = "where mu.lastname like '%" + filtro + "%'";
                break;
            case "2":
                busqueda = "where mu.username like '%" + filtro + "%'";
                break;
            case "3":
                busqueda = "where mu.idnumber like '%" + filtro + "%'";
                break;
        }
        query = " select mu.id, IFNULL(mu.apeMat,'')as apeMat, IFNULL(mu.apePat, '') as apePat, mu.firstname, mu.auth, mu.username, IFNULL(mu.idnumber, ''), IFNULL(mid.data, ''), ifnull(desNiv,''), ifnull(desGra,''), ifnull(desSede, '') "
                + " from mdl_user as mu "
                + " left join mdl_user_info_data as mid "
                + " on mid.userid = mu.id "
                + " " + busqueda + " "
                + " LIMIT " + vstart + "," + vlength + "; ";
        try {
            cn = MysqlDAOFactory.obtenerConexion(base);
            ps = cn.prepareStatement(query);
            rs = ps.executeQuery();
            while (rs.next()) {
                JSONObject obj = new JSONObject();
                obj.put("idUsuario", rs.getString(1));
                obj.put("apePatUsuario", rs.getString(2));
                obj.put("apeMatUsuario", rs.getString(3));
                obj.put("nombreUsuario", rs.getString(4));
                obj.put("tipoUsuario", rs.getString(5));
                obj.put("correoUsuario", rs.getString(6));
                obj.put("dniUsuario", rs.getString(7));
                obj.put("rolUsuario", rs.getString(8));
                obj.put("desNivel", rs.getString(9));
                obj.put("desGrado", rs.getString(10));
                obj.put("desSede", rs.getString(11));
                jsonArray.put(obj);
            }
            int filasTotales;
            String sql2 = "select count(*) as filasTotales from mdl_user as mu " + busqueda + " ;";
            PreparedStatement ps2 = cn.prepareStatement(sql2);
            ResultSet rs2 = ps2.executeQuery();
            rs2.next();
            filasTotales = rs2.getInt("filasTotales");
            jsonReturn.put("data", jsonArray);
            jsonReturn.put("recordsTotal", filasTotales);
            jsonReturn.put("recordsFiltered", filasTotales);
            jsonReturn.put("draw", draw);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            cn.close();
            rs.close();
            ps.close();
        }
        return jsonReturn;
    }


    @Override
    public int eliminarUsuario(int cod) throws Exception {
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        int rs = 0;
        String query = "";
        try {
            query = " delete from mdl_user_enrolments "
                    + " where userid = ? ";
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            pst.setInt(1, cod);
            rs = pst.executeUpdate();
            PreparedStatement pst2 = null;
            String query2 = " delete from mdl_user_info_data "
                    + " where userid = " + cod;
            pst2 = con.prepareStatement(query2);
            pst2.executeUpdate();

            PreparedStatement pst3 = null;
            String query3 = " delete from mdl_user "
                    + " where id = " + cod;
            pst3 = con.prepareStatement(query3);
            pst3.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            con.close();
            pst.close();
        }
        return rs;
    }

    @Override
    public int actualizarUsuario(UsuarioBean u) throws Exception {
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        int rs = 0;
        String query = "";
        try {
            query = " update mdl_user "
                    + " set lastname = ? + ' ' + ?, "
                    + " apePat = ?,"
                    + " apeMat = ?, "
                    + "	firstname = ?, "
                    + "	idnumber = ?, "
                    + "	email = ?, "
                    + "	username = ?,"
                    + " auth = ?,"
                    + " codNiv = ?, "
                    + " desNiv = ?, "
                    + " codGra = ?, "
                    + " desGra = ?, "
                    + " codSede = ?, "
                    + " desSede = ?, "
                    + " conTemp = ? "
                    + " where id = ? ";
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            pst.setString(1, u.getApepatUsuario());
            pst.setString(2, u.getApematUsuario());
            pst.setString(3, u.getApepatUsuario());
            pst.setString(4, u.getApematUsuario());
            pst.setString(5, u.getNombreUsuario());
            pst.setString(6, u.getDniUsuario());
            pst.setString(7, u.getCorreoUsuario());
            pst.setString(8, u.getCorreoUsuario());            
            pst.setString(9, u.getDesTipo());
            pst.setString(10, u.getCodNivel());
            pst.setString(11, u.getDesNivel());
            pst.setString(12, u.getCodGrado());
            pst.setString(13, u.getDesGrado());
            pst.setString(14, u.getCodSede());
            pst.setString(15, u.getDesSede());
            pst.setString(16, u.getContraseñaUsuario());
            pst.setString(17, u.getIdUsuario());
            rs = pst.executeUpdate();
            PreparedStatement pst2 = null;
            query = " update mdl_user_info_data "
                    + " set data = '" + u.getRolUsuario() + "' "
                    + " WHERE userid = " + u.getIdUsuario() + " ";
            pst2 = con.prepareStatement(query);
            pst2.executeUpdate();

        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            con.close();
            pst.close();
        }
        return rs; 
    }

    @Override
    public int validarUsuario(String correo) throws Exception {
        int cantidad = 0;
        String base = "moodle";
        Connection con = null;
        PreparedStatement pst = null;
        ResultSet rs = null;
        String query = " select count(*) as cantidad from mdl_user "
                + " where  username ='" + correo + "'";
        try {
            con = MysqlDAOFactory.obtenerConexion(base);
            pst = con.prepareStatement(query);
            rs = pst.executeQuery();
            rs.next();
            cantidad = rs.getInt("cantidad");
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            con.close();
            pst.close();
        }
        return cantidad;
    }

}
