/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package registroUsuario.services;

import java.util.ArrayList;
import jdk.nashorn.internal.runtime.regexp.JoniRegExp;
import org.json.JSONArray;
import org.json.JSONObject;
import registroUsuario.beans.UsuarioBean;
import registroUsuario.dao.DAOFactory;
import registroUsuario.dao.UsuarioDao;

/**
 *
 * @author sistem17user
 */
public class UsuarioService {

    DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    UsuarioDao dao = factory.getUsuarioDao();

    public int registrarUsuario(UsuarioBean u) {
        int cantidad = 0;
        try {
            cantidad = dao.registrarUsuario(u);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }

    public JSONArray listarSede() {
        JSONArray lista = null;
        try {
            lista = dao.listarSede();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }

    public JSONArray listarNivel() {
        JSONArray lista = null;
        try {
            lista = dao.listarNivel();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }

    public JSONArray listarGrado(int parent) {
        JSONArray lista = null;
        try {
            lista = dao.listarGrado(parent);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }

    public JSONObject listarUsuario(String tipoBusqueda, String filtro, int vstart, int vlength, String draw) {
        JSONObject obj = null;
        try {
            obj = dao.listarUsuario(tipoBusqueda, filtro, vstart, vlength, draw);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return obj;
    }

    public int actualizarUsuario(UsuarioBean u) {
        int cantidad = 0;
        try {
            cantidad = dao.actualizarUsuario(u);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;        
    }
    
    public int eliminarUsuario(int cod){
        int cantidad = 0;
        try {
            cantidad = dao.eliminarUsuario(cod);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }
    public int validarUsuario(String correo){
        int cantidad = 0;
        try {
            cantidad = dao.validarUsuario(correo);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }
   

}
