/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package registroUsuario.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import registroUsuario.services.CursoService;

/**
 *
 * @author sistem17user
 */
@WebServlet(name = "CursoServlet", urlPatterns = {"/CursoServlet"})
public class CursoServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String accion = request.getParameter("accion");
        if (accion.equals("listarNivel")) {
            listarNivel(request, response);
        } else if (accion.equals("listarGrado")) {
            listarGrado(request, response);
        } else if (accion.equals("listarCurso")) {
            listarCurso(request, response);
        } else if (accion.equals("asignarCurso")) {
            asignarCurso(request, response);
        } else if (accion.equals("listarUsuarioCurso")) {
            listarUsuarioCurso(request, response);
        } else if (accion.equals("eliminarCurso")){
            eliminarCurso(request, response);
        }
    }

    private void listarNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        CursoService service = new CursoService();
        JSONArray lista = service.listarNivel();
        out.println(lista.toString());
    }

    private void listarGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        CursoService service = new CursoService();
        int parent = Integer.parseInt(request.getParameter("parent"));
        JSONArray lista = service.listarGrado(parent);
        out.println(lista.toString());
    }

    private void listarCurso(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        CursoService service = new CursoService();
        int parent = Integer.parseInt(request.getParameter("parent"));
        JSONArray lista = service.listarCursos(parent);
        out.println(lista.toString());
    }

    private void asignarCurso(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int cboCurso = Integer.parseInt(request.getParameter("cboCurso"));
        String userid = request.getParameter("userid");
        String cboGrado = request.getParameter("cboGrado");
        
        CursoService service = new CursoService();
        
        int enrolid = 0;
        if(cboCurso!=0){
            enrolid = service.obtenerEnrol(cboCurso);
        }        
        int rs  = service.asignarCurso(enrolid, userid, cboCurso, cboGrado);
        
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        out.println(rs);
    }

    private void listarUsuarioCurso(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        CursoService service = new CursoService();
        String id = request.getParameter("userid");
        String draw = request.getParameter("draw");
        int vstart = Integer.parseInt(request.getParameter("start"));
        int vlength = Integer.parseInt(request.getParameter("length"));
        JSONObject lista = service.listarCursos(id, vstart, vlength, draw);
        out.println(lista.toString());
    }

    private void eliminarCurso(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        CursoService service = new CursoService();
        String codCurso = request.getParameter("codCurso");
        int rs = service.eliminarCursos(codCurso);
        out.println(rs);
    }
    
    

}
