/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package registroUsuario.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import registroUsuario.beans.UsuarioBean;
import registroUsuario.services.UsuarioService;

/**
 *
 * @author sistem17user
 */
@WebServlet(name = "UsuarioServlet", urlPatterns = {"/UsuarioServlet"})
public class UsuarioServlet extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String accion = request.getParameter("accion");
        if (accion.equals("listarSede")) {
            listarSede(request, response);
        } else if (accion.equals("listaNivel")) {
            listaNivel(request, response);
        } else if (accion.equals("listaGrado")) {
            listaGrado(request, response);
        } else if (accion.equals("registrarUsuario")) {
            registrarUsuario(request, response);
        } else if (accion.equals("listarUsuario")) {
            listarUsuario(request, response);
        } else if (accion.equals("actualizarUsuario")) {
            actualizarUsuario(request, response);
        } else if (accion.equals("eliminarUsuario")) {
            eliminarUsuario(request, response);
        } else if (accion.equals("validarUsuario")) {
            validarUsuario(request, response);
        }
    }

    private void listarSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        UsuarioService service = new UsuarioService();
        JSONArray lista = service.listarSede();
        out.println(lista.toString());
    }

    private void listaNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        UsuarioService service = new UsuarioService();
        JSONArray lista = service.listarNivel();
        out.println(lista.toString());
    }

    private void listaGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json");
        int parent = Integer.parseInt(request.getParameter("cboNivel"));
        PrintWriter out = response.getWriter();
        UsuarioService service = new UsuarioService();
        JSONArray lista = service.listarGrado(parent);
        out.println(lista.toString());
    }

    private void registrarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        UsuarioBean u = new UsuarioBean();
        UsuarioService service = new UsuarioService();
        u.setDesTipo(request.getParameter("tipo"));
        u.setCorreoUsuario(request.getParameter("correo"));
        u.setDniUsuario(request.getParameter("dni"));
        u.setNombreUsuario(request.getParameter("nombre"));
        u.setApepatUsuario(request.getParameter("apepat"));
        u.setApematUsuario(request.getParameter("apemat"));
        u.setRolUsuario(request.getParameter("rol"));
        u.setCodNivel(request.getParameter("codNivel"));
        u.setDesNivel(request.getParameter("desNivel"));
        u.setCodSede(request.getParameter("codSede"));
        u.setDesSede(request.getParameter("desSede"));
        u.setCodGrado(request.getParameter("codGrado"));
        u.setDesGrado(request.getParameter("desGrado"));
        u.setContraseñaUsuario(request.getParameter("conUser"));

        int rs = service.registrarUsuario(u);
        out.println(rs);
    }

    private void listarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        PrintWriter pw = response.getWriter();
        UsuarioService service = new UsuarioService();

        response.setContentType("application/json");
        String valorCombo = request.getParameter("valorCombo");
        String filtro = request.getParameter("filtro");
        String draw = request.getParameter("draw");
        int vstart = Integer.parseInt(request.getParameter("start"));
        int vlength = Integer.parseInt(request.getParameter("length"));
        JSONObject jsonReturn = service.listarUsuario(valorCombo, filtro, vstart, vlength, draw);

        pw.println(jsonReturn);
    }

    private void actualizarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        UsuarioBean u = new UsuarioBean();
        UsuarioService service = new UsuarioService();
        u.setDesTipo(request.getParameter("tipo"));
        u.setCorreoUsuario(request.getParameter("correo"));
        u.setDniUsuario(request.getParameter("dni"));
        u.setNombreUsuario(request.getParameter("nombre"));
        u.setApepatUsuario(request.getParameter("apepat"));
        u.setApematUsuario(request.getParameter("apemat"));
        u.setRolUsuario(request.getParameter("rol"));
        u.setCodNivel(request.getParameter("codNivel"));
        u.setDesNivel(request.getParameter("desNivel"));
        u.setCodSede(request.getParameter("codSede"));
        u.setDesSede(request.getParameter("desSede"));
        u.setCodGrado(request.getParameter("codGrado"));
        u.setDesGrado(request.getParameter("desGrado"));
        u.setContraseñaUsuario(request.getParameter("conUser"));
        u.setIdUsuario(request.getParameter("id"));
        int rs = service.actualizarUsuario(u);
        out.println(rs);
    }

    private void eliminarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        UsuarioService service = new UsuarioService();
        int cod = Integer.parseInt(request.getParameter("id"));

        int rs = service.eliminarUsuario(cod);
        out.println(rs);
    }

    private void validarUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        UsuarioService service = new UsuarioService();
        String correo = request.getParameter("correo");
        int rs = service.validarUsuario(correo);
        out.println(rs);
    }

}
