$(document).ready(function () {
    listarNivel();
    listarGrado();
    listarCurso();
    validarCombos();
    obtenerDatosAlumno();
    asignarCurso();
    listarCursosUsuario();
    listarCursosEliminar();
    seleccionarTodos();
    retornarLista();

});
function listarNivel() {
    $.ajax({
        type: 'POST',
        url: "../CursoServlet?accion=listarNivel",
        dataType: 'JSON',
        success: function (result) {
            var print = " <option value=''>Seleccione Nivel</option> "
            for (var i in result) {
                print += " <option value =" + result[i].codNivel + ">" + result[i].desNivel + "</option> ";
            }
            $("#cboNivel1").html(print);
        }

    });
}

function listarGrado() {
    $("#cboNivel1").on('change', function () {
        var cboNivel1 = $("#cboNivel1").val();
        $.ajax({
            type: 'POST',
            url: "../CursoServlet?accion=listarGrado",
            dataType: 'JSON',
            data: 'parent=' + cboNivel1,
            success: function (result) {
                var print = " <option value=''>Seleccione Grado</option> ";
                for (var i in result) {
                    print += " <option value =" + result[i].codGrado + ">" + result[i].desGrado + "</option> ";
                }
                $("#cboGrado1").html(print);
            }

        });
    });

}

function listarCurso() {
    $('#cboGrado1').on('change', function () {
        var cboGrado1 = $('#cboGrado1').val();
        $.ajax({
            type: 'POST',
            url: "../CursoServlet?accion=listarCurso",
            dataType: 'JSON',
            data: 'parent=' + cboGrado1,
            success: function (result) {
                var print = " <option value=''>Seleccione Curso</option> "
                        + " <option value='0' style='font-weight: bold'>Todos</option> ";
                for (var i in result) {
                    print += " <option value =" + result[i].codCurso + ">" + result[i].desCurso + "</option> ";
                }
                $("#cboCurso").html(print);
            }
        });

    });

}

function validarCombos() {
    $('#cboGrado1, #cboCurso').attr('disabled', true);
    $('#cboGrado1').html("<option value=''>Seleccione Grado</option>");
    $('#cboCurso').html("<option value=''>Seleccione Curso</option>");
    listarGrado();
    listarCurso();
    $('#cboNivel1').on('change', function () {
        var cboNivel1 = $('#cboNivel1').val();
        if (cboNivel1 == '') {
            $('#cboGrado1, #cboCurso').attr('disabled', true);
            $('#cboGrado1').html("<option value=''>Seleccione Grado</option>");
            $('#cboCurso').html("<option value=''>Seleccione Curso</option>");
            listarGrado();
            listarCurso();
        } else if (cboNivel1 != '') {
            $('#cboGrado1').attr('disabled', false);
        }
    });
    $('#cboGrado1').on('change', function () {
        var cboGrado1 = $('#cboGrado1').val();
        if (cboGrado1 == '') {
            $('#cboCurso').attr('disabled', true);
            $('##cboCurso').html("<option value=''>Seleccione Curso</option>");
            listarCurso();
        } else if (cboGrado1 != '') {
            $('#cboCurso').attr('disabled', false);
        }
    });

}

var userid = null;

function obtenerDatosAlumno() {
    jsonname = [];
    try {
        jsonname.push(JSON.parse(window.name));
    } catch (e) {
        try {
            jsonname = JSON.parse(window.name);
        } catch (e) {
            console.log('vacio');
        }
    }
    for (var i in jsonname) {
        var rol = jsonname[i].rolUsuario;
        var id = jsonname[i].idUsuario;
        var nombre = jsonname[i].nombreUsuario;
        var pat = jsonname[i].apeMatUsuario;
        var mat = jsonname[i].apePatUsuario;
        var correo = jsonname[i].correoUsuario;
        var dni = jsonname[i].dniUsuario;
        var sede = jsonname[i].desSede;
        var grado = jsonname[i].desGrado;
        var nivel = jsonname[i].desNivel;
        userid = jsonname[i].idUsuario;
        $('#lblId').text(MaysPrimera(id));
        $('#lblNombre').text(MaysPrimera(pat) + " " + MaysPrimera(mat) + ", " + MaysPrimera(nombre));
        $('#lblRol').text(MaysPrimera(rol));
        $('#lblDni').text(MaysPrimera(dni));
        $('#lblCorreo').text(correo);
        $('#lblGrado').text(MaysPrimera(grado));
        $('#lblNivel').text(MaysPrimera(nivel));
        $('#lblSede').text(MaysPrimera(sede));
    }
}




function asignarCurso() {
    $('#btnAsignar').on('click', function () {
        var cboCurso = $('#cboCurso').val();
        var cboGrado = $('#cboGrado1').val();
        var valid = $('#formCursos').validate({
            rules: {
                cboNivel1: {required: true},
                cboGrado1: {required: true},
                cboCurso: {required: true}
            },
            messages: {
                cboNivel1: {required: "Seleccione un Nivel"},
                cboGrado1: {required: "Seleccione un Grado"},
                cboCurso: {required: "Seleccione un Curso"}
            }
        });
        if (valid.form()) {
            $.ajax({
                type: 'POST',
                url: "../CursoServlet?accion=asignarCurso",
                data: "cboCurso=" + cboCurso
                        + "&cboGrado=" + cboGrado
                        + "&userid=" + userid,
                success: function (data) {
                    if (data != -1 && data != 0) {
                        swal({
                            title: "Curso correctamente registrado",
                            type: "success"
                        });
                        validarCombos();
                        listarCursosUsuario();
                    } else if (data == 0) {
                        swal({
                            title: "Curso repetido",
                            text: "No puedes asignar dos veces el mismo curso al mismo alumno",
                            type: "warning"
                        });
                    }
                }
            });
        }

    });
}

function listarCursosUsuario() {
    var json = {
        userid: userid
    };
    $("#tblCursos").DataTable().destroy();
    var table = $("#tblCursos").DataTable({
        "language": {
            "lengthMenu": "Mostrar: _MENU_",
            "zeroRecords": "No se encontraron resultados",
            "info": "&nbsp;&nbsp;&nbsp; Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
            "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
            "search": "Filtrar:",
            "loadingRecords": "Cargando...",
            "processing": "Procesando...",
            "scrollY": false,
            "paginate": {
                "first": "First",
                "last": "Last",
                "next": "Siguiente",
                "previous": "Anterior"
            }
        },
        "ajax": {
            type: 'POST',
            "url": '../CursoServlet?accion=listarUsuarioCurso',
            data: json
        },
        bSort: false,
        responsive: true,
        bInfo: true,
        searching: false,
        bLengthChange: false,
        bFilter: false,
        "processing": true,
        "serverSide": true,
        "ordering": false,
        "iDisplayLength": 20,
        "columnDefs": [
            {"targets": [0], className: "text-center", "width": "5%"},
            {"targets": [1], className: "text-left", "width": "7%"},
            {"targets": [2], className: "text-left", "width": "15%"},
            {"targets": [3], className: "text-center", "width": "5%"}
        ],
        "columns": [
            {"data": "idCursos"},
            {"data": "categoria"},
            {"data": "curso"},
            {"data": null, "render": function () {
                    return " <ul class='icons-list'> "
                            + " <li>"
                            + " <i id='eliminar' class='glyphicon glyphicon-trash text-warning-800' title='ELIMINAR CURSO'></i>"
                            + " </li>"
                            + " </ul>";
                }

            }
        ]
    });
    $('#tblCursos tbody').on('click', '#eliminar', function () {
        var data = table.row($(this).parents('tr')).data();
        for (var i in data) {
            var codCurso = data["idCursos"];
        }
        var json = {
            codCurso: codCurso
        };
        swal({
            title: "¿Esta seguro de eliminar este curso?",
            text: "¡Los cambios serán permanentes!",
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#EF5350",
            confirmButtonText: "Si, eliminar",
            cancelButtonText: "No, cancelar",
            closeOnConfirm: false,
            closeOnCancel: true
        },
                function (isConfirm) {
                    if (isConfirm) {
                        $.ajax({
                            type: 'POST',
                            url: '../CursoServlet?accion=eliminarCurso',
                            data: json,
                            success: function (data) {
                                if (data != -1) {
                                    swal({
                                        title: "Curso correctamente Eliminado",
                                        confirmButtonColor: "#66BB6A",
                                        type: "success"
                                    });
                                    listarCursosUsuario();
                                }
                            }
                        });
                    }
                });
    });
    $('#btnSeleccionar').removeClass('hide');
    $('#btnElminar').addClass('hide');
    $('#btnTodos').addClass('hide');
    $('#btnCancelar').addClass('hide');
}
function listarCursosEliminar() {
    $('#btnSeleccionar').on('click', function () {
        $('#btnSeleccionar').addClass('hide');
        $('#btnElminar').removeClass('hide');
        $('#btnTodos').removeClass('hide');
        $('#btnCancelar').removeClass('hide');
        var json = {
            userid: userid
        };
        $("#tblCursos").DataTable().destroy();
        var table = $("#tblCursos").DataTable({
            "language": {
                "lengthMenu": "Mostrar: _MENU_",
                "zeroRecords": "No se encontraron resultados",
                "info": "&nbsp;&nbsp;&nbsp; Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
                "search": "Filtrar:",
                "loadingRecords": "Cargando...",
                "processing": "Procesando...",
                "scrollY": false,
                "paginate": {
                    "first": "First",
                    "last": "Last",
                    "next": "Siguiente",
                    "previous": "Anterior"
                }
            },
            "ajax": {
                type: 'POST',
                "url": '../CursoServlet?accion=listarUsuarioCurso',
                data: json
            },
            bSort: false,
            responsive: true,
            bInfo: true,
            searching: false,
            bLengthChange: false,
            bFilter: false,
            "processing": true,
            "serverSide": true,
            "ordering": false,
            "iDisplayLength": 20,
            "columnDefs": [
                {"targets": [0], className: "text-center", "width": "5%"},
                {"targets": [1], className: "text-left", "width": "7%"},
                {"targets": [2], className: "text-left", "width": "15%"},
                {"targets": [3], className: "text-center", "width": "5%"}
            ],
            "columns": [
                {"data": "idCursos"},
                {"data": "categoria"},
                {"data": "curso"},
                {"data": null, "render": function () {
                        return " <input class='codigo' type='checkbox' value=''>";
                    }

                }
            ]
        });
        $('#btnElminar').on('click', function () {
            var concat = "";
            $('#tblCursos tbody .codigo').each(function () {
                if ($(this).is(':checked') == true) {
                    var data = table.row($(this).parents('tr')).data();
                    concat += data["idCursos"] + ",";
                }

            });
            var concatcut = concat.slice(0, -1);
            var json = {
                codCurso: concatcut
            };
            swal({
                title: "¿Esta seguro de realizar esta acción?",
                text: "¡Los cambios serán permanentes!",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#EF5350",
                confirmButtonText: "Si, eliminar",
                cancelButtonText: "No, cancelar",
                closeOnConfirm: false,
                closeOnCancel: true
            },
                    function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: 'POST',
                                url: '../CursoServlet?accion=eliminarCurso',
                                data: json,
                                success: function (data) {
                                    if (data != -1) {
                                        swal({
                                            title: "Cursos correctamente Eliminados",
                                            confirmButtonColor: "#66BB6A",
                                            type: "success"
                                        });
                                        listarCursosUsuario();
                                        $('#btnSeleccionar').removeClass('hide');
                                        $('#btnElminar').addClass('hide');
                                        $('#btnTodos').addClass('hide');
                                        $('#btnCancelar').addClass('hide');
                                    }
                                }
                            });
                        }
                    });
        });

    });
}

function MaysPrimera(string) {
    string = string.toLowerCase();
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function seleccionarTodos() {
    $('#btnTodos').on('click', function () {
        if ($("input:checkbox").is(':checked') == true) {
            $("input:checkbox").prop('checked', false);
        } else if ($("input:checkbox").is(':checked') == false) {
            $("input:checkbox").prop('checked', true);
        }
    });
}
function retornarLista() {
    $('#btnCancelar').on('click', function () {
        listarCursosUsuario();
        $('#btnSeleccionar').removeClass('hide');
        $('#btnElminar').addClass('hide');
        $('#btnTodos').addClass('hide');
        $('#btnCancelar').addClass('hide');
    });
}