$(document).ready(function () {
    datosUsuario.listarUsuario();
    listarSede();
    listarNivel();
    listarGrado();
    validarCombos();
    generarCorreo();
    registrarUsuario();
    validarInputs();
});
var datosUsuario = {listarUsuario: function () {
        $("#tblUsuario").DataTable().destroy();
        var filtro = $('#txtFiltro').val();
        var valorCombo = $('#cboFiltro').val();
        var json = {
            valorCombo: valorCombo,
            filtro: filtro
        };
        var table = $("#tblUsuario").DataTable({
            "language": {
                "lengthMenu": "Mostrar: _MENU_",
                "zeroRecords": "No se encontraron resultados",
                "info": "&nbsp;&nbsp;&nbsp; Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
                "search": "Filtrar:",
                "loadingRecords": "Cargando...",
                "processing": "Procesando...",
                "scrollY": false,
                "paginate": {
                    "first": "First",
                    "last": "Last",
                    "next": "Siguiente",
                    "previous": "Anterior"
                }
            },
            "ajax": {
                type: 'POST',
                "url": '../UsuarioServlet?accion=listarUsuario',
                data: json
            },
            bSort: false,
            responsive: true,
            bInfo: true,
            searching: false,
            bLengthChange: false,
            bFilter: false,
            "processing": true,
            "serverSide": true,
            "ordering": false,
            "columnDefs": [
                {"targets": [0], className: "text-center", "width": "5%"},
                {"targets": [1], className: "text-center", "width": "6%"},
                {"targets": [2], className: "text-left", "width": "6%"},
                {"targets": [3], className: "text-left", "width": "6%"},
                {"targets": [4], className: "text-left", "width": "6%"},
                {"targets": [5], className: "text-center", "width": "8%"},
                {"targets": [6], className: "text-left", "width": "10%"},
                {"targets": [7], className: "text-center", "width": "10%"},
                {"targets": [8], className: "text-center", "width": "7%"},
                {"targets": [9], visible: false},
                {"targets": [10], visible: false},
                {"targets": [11], visible: false}
            ],
            "columns": [
                {"data": "idUsuario"},
                {"data": "dniUsuario"},
                {"data": "apeMatUsuario"},
                {"data": "apePatUsuario"},
                {"data": "nombreUsuario"},
                {"data": "tipoUsuario"},
                {"data": "correoUsuario"},
                {"data": "rolUsuario"},
                {"data": null, "render": function () {
                        return " <ul class='icons-list'> "
                                + " <li>"
                                + " <a href='asignarCursos.jsp'><i id='asignarCursos' class='icon-stack-text text-info-600' title='ASIGNAR CURSOS'></i></a>"
                                + " </li>"
                                + " <li>"
                                + " <i id='editar' class='glyphicon glyphicon-pencil text-primary-800'  data-placement='left' title='EDITAR USUARIO'></i>"
                                + " </li>"
                                + " <li>"
                                + " <i id='eliminar' class='glyphicon glyphicon-trash text-warning-800' title='ELIMINAR USUARIO'></i>"
                                + " </li>"
                                + " </ul>";
                    }

                },
                {"data": "desNivel"},
                {"data": "desGrado"},
                {"data": "desSede"}
            ]

        });

        $('#tblUsuario tbody').on('click', '#editar', function () {
            $('#btnActualizarUsuario').attr('disabled', false);
            $('#btnActualizarUsuario').removeClass('hide');
            $('#btnRegistrarUsuario').attr('disabled', true);
            $('#btnRegistrarUsuario').addClass('hide');
            var data = table.row($(this).parents('tr')).data();
            for (var i in data) {
                var idUsuario = data["idUsuario"];
                var apepat = data["apePatUsuario"];
                var apemat = data["apeMatUsuario"];
                var nombreUsuario = data["nombreUsuario"];
                var correoUsuario = data["correoUsuario"];
                var dniUsuario = data["dniUsuario"];
                var rolUsuario = data["rolUsuario"];
            }
            $("#modal_theme_primary").modal("show");
            $('#cboTipo').val('oidc');
            $('#txtDni').val(dniUsuario);
            $('#txtCorreo').val(correoUsuario);
            $('#txtNombre').val(nombreUsuario);
            $('#txtApemat').val(apemat);
            $('#txtApepat').val(apepat);
            $('#cboRol').val(rolUsuario);
            $('#btnActualizarUsuario').on('click', function () {
                var validarForm = $("#formAgregar").validate({
                    rules: {
                        cboRol: {required: true},
                        cboTipo: {required: true},
                        txtDni: {required: true,
                            minlength: 8},
                        btn_ver: {required: true},
                        txtApepat: {required: true},
                        txtApemat: {required: true},
                        txtNombre: {required: true},
                        cboSede: {required: true},
                        cboNivel: {required: true},
                        cboGrado: {required: true},
                        txtCorreo: {required: true}
                    },
                    messages: {
                        cboRol: {required: "Seleccione un Rol"},
                        cboTipo: {required: "Seleccione un Tipo"},
                        txtDni: {required: "Ingrese un DNI",
                            minlength: "Son 8 dígitos"},
                        btn_ver: {required: "Ingrese una Contraseña"},
                        txtApepat: {required: "Ingrese Apellido Paterno"},
                        txtApemat: {required: "Ingrese Apellido Materno"},
                        txtNombre: {required: "Ingrese un Nombre"},
                        cboSede: {required: "Seleccione una Sede"},
                        cboNivel: {required: "Seleccione un Nivel"},
                        cboGrado: {required: "Seleccione un Grado"},
                        txtCorreo: {required: "Ingrese Correo"}
                    },
                    errorPlacement:
                            function (error, element) {
                                if (element.attr("id") == "btn_ver") {
                                    error.insertAfter("#txtContraseña");
                                } else {
                                    error.insertAfter(element);
                                }
                            }
                });
                if (validarForm.form()) {
                    swal({
                        title: "Esta seguro de actualizar este usuario?",
                        text: "Se agregará al listado de usuario registrados",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#EF5350",
                        confirmButtonText: "Si, actualizar",
                        cancelButtonText: "No, cancelar",
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                            function (isConfirm) {
                                if (isConfirm) {
                                    var rol = $('#cboRol').val();
                                    var tipo = $('#cboTipo').val();
                                    var correo = $('#txtCorreo').val();
                                    var dni = $('#txtDni').val();
                                    var nombre = $('#txtNombre').val();
                                    var apemat = $('#txtApemat').val();
                                    var apepat = $('#txtApepat').val();
                                    var codSede = $('#cboSede').val();
                                    var desSede = $('#cboSede option:selected').text();
                                    var codGrado = $('#cboGrado').val();
                                    var desGrado = $('#cboGrado option:selected').text();
                                    var codNivel = $('#cboNivel').val();
                                    var desNivel = $('#cboNivel option:selected').text();
                                    var conUser = $('#btn_ver').val();
                                    if (!desGrado.indexOf('Seleccionar') != -1) {
                                        desGrado = "";
                                    }
                                    if (!desNivel.indexOf('Seleccionar') != -1) {
                                        desNivel = "";
                                    }
                                    if (!desSede.indexOf('Seleccionar') != -1) {
                                        desSede = "";
                                    }
                                    $.ajax({
                                        type: 'POST',
                                        url: "../UsuarioServlet?accion=actualizarUsuario",
                                        data: "tipo=" + tipo +
                                                "&correo=" + correo +
                                                "&dni=" + dni +
                                                "&nombre=" + nombre +
                                                "&apemat=" + apemat +
                                                "&apepat=" + apepat +
                                                "&rol=" + rol +
                                                "&codNivel=" + codNivel +
                                                "&desNivel=" + desNivel +
                                                "&codSede=" + codSede +
                                                "&desSede=" + desSede +
                                                "&codGrado=" + codGrado +
                                                "&desGrado=" + desGrado +
                                                "&id=" + idUsuario +
                                                "&conUser=" + conUser,
                                        success: function (data) {
                                            if (data != -1) {
                                                swal({
                                                    title: "Usuario correctamente Actualizado",
                                                    confirmButtonColor: "#66BB6A",
                                                    type: "success"
                                                });
                                                $("#modal_theme_primary").modal("hide");
                                                document.getElementById("formAgregar").reset();
                                                datosUsuario.listarUsuario();
                                                validarCombos();
                                                $('#btnActualizarUsuario').addClass('hide');
                                                $('#btnRegistrarUsuario').removeClass('hide');
                                                $('#btnActualizarUsuario').attr('disabled', true);
                                                $('#btnRegistrarUsuario').attr('disabled', false);
                                            }
                                        }
                                    });
                                }



                            });
                }
            });
        });
        $('#tblUsuario tbody').on('click', '#eliminar', function () {
            var data = table.row($(this).parents('tr')).data();
            for (var i in data) {
                var idUsuario = data["idUsuario"];
            }
            swal({
                title: "¿Esta seguro de eliminar este usuario?",
                text: "¡Los cambios serán permanentes!",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#EF5350",
                confirmButtonText: "Si, eliminar",
                cancelButtonText: "No, cancelar",
                closeOnConfirm: false,
                closeOnCancel: true
            },
                    function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: 'POST',
                                url: "../UsuarioServlet?accion=eliminarUsuario",
                                data: "&id=" + idUsuario,
                                success: function (data) {
                                    if (data != -1) {
                                        swal({
                                            title: "Usuario correctamente Eliminado",
                                            confirmButtonColor: "#66BB6A",
                                            type: "success"
                                        });
                                        datosUsuario.listarUsuario();
                                    }
                                }
                            });
                        }



                    });
        });
        $('#tblUsuario tbody').on('click', '#asignarCursos', function () {
            var data = table.row($(this).parents('tr')).data();
            window.location = 'editarAlumno.jsp';
            window.name = JSON.stringify(data);
        });
    }
};
function listarSede() {
    $.ajax({
        type: 'POST',
        url: "../UsuarioServlet?accion=listarSede",
        dataType: 'JSON',
        success: function (result) {
            var print = "<option value=''>Seleccionar Sede</option>";
            for (var i in result) {
                print += "<option value =" + result[i].codSede + ">" + result[i].desSede + "</option>";
            }
            $("#cboSede").html(print);
        }
    });
}

function listarNivel() {
    $.ajax({
        type: 'POST',
        url: "../UsuarioServlet?accion=listaNivel",
        dataType: 'JSON',
        success: function (result) {
            var print = "<option value=''>Seleccionar Nivel</option>";
            for (var i in result) {
                print += "<option value =" + result[i].codNivel + ">" + result[i].desNivel + "</option>";
            }
            $("#cboNivel").html(print);
        }
    });
}

function listarGrado() {
    $("#cboNivel").on("change", function () {
        var cboNivel = $("#cboNivel").val();
        $.ajax({
            type: 'POST',
            url: "../UsuarioServlet?accion=listaGrado",
            data: "cboNivel=" + cboNivel,
            dataType: 'JSON',
            success: function (result) {
                var print = "<option value=''>Seleccionar Grado</option>";
                for (var i in result) {
                    print += "<option value=" + result[i].codGrado + ">" + result[i].desGrado + "</option>";
                }
                $("#cboGrado").html(print);
            }
        });
    });
}


function validarCombos() {
    $('#cboRol').attr('disabled', false);
    $('#cboSede, #cboNivel, #cboGrado').attr('disabled', true);
    $('#nivel, #grado, #sede').attr('class', 'hide');
    $('#cboRol').on('change', function () {
        var rol = $('#cboRol').val();
        if (rol == 'ESTUDIANTE') {
            $('#cboSede, #cboNivel').attr('disabled', false);
            $('#nivel').attr('class', 'col-md-3');
            $('#sede').attr('class', 'col-md-3');
            $('#cboGrado').html("<option value='0'>Seleccionar Grado</option>");
            listarGrado();
        } else if (rol == 'DOCENTE') {
            $('#cboSede, #cboNivel, #cboGrado').attr('disabled', true);
            $('#nivel, #grado, #sede').attr('class', 'hide');
            $('#cboGrado').html("<option value='0'>Seleccionar Grado</option>");
            $('#cboNivel').html("<option value='0'>Seleccionar Nivel</option>");
            listarNivel();
            listarGrado();
        } else if (rol == '') {
            $('#nivel, #grado, #sede').attr('class', 'hide');
            $('#cboSede, #cboNivel, #cboGrado').attr('disabled', true);
            $('#cboGrado').html("<option value='0'>Seleccionar Grado</option>");
            $('#cboNivel').html("<option value='0'>Seleccionar Nivel</option>");
            $('#cboSede').html("<option value='0'>Seleccionar Sede</option>");
            listarSede();
            listarNivel();
            listarGrado();
        } else if (rol == 'DIRECTOR PRIMARIA' || rol == 'DIRECTOR SECUNDARIA') {
            $('#nivel, #grado').attr('class', 'hide');
            $('#cboNivel, #cboGrado').attr('disabled', true);
            $('#cboSede').attr('disabled', false);
            $('#sede').attr('class', 'col-md-3');
            $('#cboGrado').html("<option value='0'>Seleccionar Grado</option>");
            $('#cboNivel').html("<option value='0'>Seleccionar Nivel</option>");
            listarSede();
            listarNivel();
            listarGrado();
        }
    });
    $('#cboNivel').on('change', function () {
        var nivel = $('#cboNivel').val();
        if (nivel == 3 || nivel == 4 || nivel == 0) {
            $('#cboGrado').attr('disabled', true);
            $('#grado').attr('class', 'hide');
            $('#cboGrado').html("<option value='0'>Seleccionar Grado</option>");
            listarGrado();
        } else if (nivel != 0 || nivel != 3 || nivel != 4) {
            $('#cboGrado').attr('disabled', false);
            $('#grado').attr('class', 'col-md-3');
        }
    });
}

function validarInputs() {
    $('#txtDni').prop('maxlength', '8');
    $('#txtDni').validCampo('01234456789');
    $('#btn_ver').validCampo('abcdefghijklmnñopqrstuvwxyzáéiou01234456789');
    $('#txtApepat').validCampo(' abcdefghijklmnñopqrstuvwxyzáéiou');
    $('#txtApepat').attr('maxlength', 30);
    $('#txtApemat').validCampo(' abcdefghijklmnñopqrstuvwxyzáéiou');
    $('#txtApemat').attr('maxlength', 30);
    $('#txtNombre').validCampo(' abcdefghijklmnñopqrstuvwxyzáéiou');
    $('#txtNombre').attr('maxlength', 30);
}

function generarCorreo() {
    var correo = $('#txtCorreo').val();
    $('#cboRol').on('change', function () {
        var rol = $('#cboRol').val();
        if (rol == '0') {
            $('#spanCorreo').addClass('hide');
            $('#txtDni').val("");
            correo = $('#txtCorreo').val("");
            $('#txtCorreo').attr('disabled', true);
            $('#txtCorreo').attr('placeholder', 'Correo Autogenerado');
            correo = 'Correo Autogenerado';
        } else if (rol == 'DIRECTOR PRIMARIA' || rol == 'DIRECTOR SECUNDARIA') {
            $('#spanCorreo').removeClass('hide');
            correo = $('#txtCorreo').val("");
            $('#txtDni').val("");
            $('#txtCorreo').attr('disabled', false);
            $('#txtCorreo').attr('placeholder', 'Ingrese Correo');
            $('#txtCorreo').validCampo('abcdefghijklmnñopqrstuvwxyz1234567890._@');
        } else if (rol == 'ESTUDIANTE' || rol == 'DOCENTE' && rol != 'DIRECTOR PRIMARIA' && rol != 'DIRECTOR SECUNDARIA') {
            $('#spanCorreo').addClass('hide');
            $('#txtDni').val("");
            correo = $('#txtCorreo').val("");
            $('#txtCorreo').attr('disabled', true);
            $('#txtCorreo').attr('placeholder', 'Correo Autogenerado');
        }
    });
    $('#txtDni').keyup(function () {
        var dni = $('#txtDni').val();
        var rol = $('#cboRol').val();
        if (rol == 'ESTUDIANTE' || rol == 'DOCENTE') {
            var letraRol = $("#cboRol option:selected").text().substring(1, 0).toLowerCase();
            correo = letraRol + dni + "@sistemahelicoidal.edu.pe";
            $('#txtCorreo').val(correo);
        }
    });
}

function registrarUsuario() {
    $('#btnRegistrarUsuario').on('click', function () {
        var validarForm = $("#formAgregar").validate({
            rules: {
                cboRol: {required: true},
                cboTipo: {required: true},
                txtDni: {required: true,
                    minlength: 8},
                btn_ver: {required: true},
                txtApepat: {required: true},
                txtApemat: {required: true},
                txtNombre: {required: true},
                cboSede: {required: true},
                cboNivel: {required: true},
                cboGrado: {required: true},
                txtCorreo: {required: true}
            },
            messages: {
                cboRol: {required: "Seleccione un Rol"},
                cboTipo: {required: "Seleccione un Tipo"},
                txtDni: {required: "Ingrese un DNI",
                    minlength: "Son 8 dígitos"},
                btn_ver: {required: "Ingrese una Contraseña"},
                txtApepat: {required: "Ingrese Apellido Paterno"},
                txtApemat: {required: "Ingrese Apellido Materno"},
                txtNombre: {required: "Ingrese un Nombre"},
                cboSede: {required: "Seleccione una Sede"},
                cboNivel: {required: "Seleccione un Nivel"},
                cboGrado: {required: "Seleccione un Grado"},
                txtCorreo: {required: "Ingrese Correo"}
            },
            errorPlacement:
                    function (error, element) {
                        if (element.attr("id") == "btn_ver") {
                            error.insertAfter("#txtContraseña");
                        } else {
                            error.insertAfter(element);
                        }
                    }
        });
        if (validarForm.form()) {
            swal({
                title: "Esta seguro de registrar esta persona?",
                text: "Se agregará al listado de personas registradas",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#EF5350",
                confirmButtonText: "Si, registrar",
                cancelButtonText: "No, cancelar",
                closeOnConfirm: false,
                closeOnCancel: true
            },
                    function (isConfirm) {
                        if (isConfirm) {
                            var rol = $('#cboRol').val();
                            var tipo = $('#cboTipo').val();
                            var correo = $('#txtCorreo').val();
                            var dni = $('#txtDni').val();
                            var nombre = $('#txtNombre').val();
                            var apemat = $('#txtApemat').val();
                            var apepat = $('#txtApepat').val();
                            var codSede = $('#cboSede').val();
                            var codGrado = $('#cboGrado').val();
                            var codNivel = $('#cboNivel').val();
                            var conUser = $('#btn_ver').val();
                            var desSede = "";
                            var desNivel = "";
                            var desGrado = "";
                            if (codSede != "") {
                                desSede = $('#cboSede option:selected').text();
                            }
                            if (codNivel != "") {
                                desNivel = $('#cboNivel option:selected').text();
                            }
                            if (codGrado != "") {
                                desGrado = $('#cboGrado option:selected').text();
                            }
                            $.ajax({
                                type: 'POST',
                                url: "../UsuarioServlet?accion=registrarUsuario",
                                data: "tipo=" + tipo +
                                        "&correo=" + correo +
                                        "&dni=" + dni +
                                        "&nombre=" + nombre +
                                        "&apemat=" + apemat +
                                        "&apepat=" + apepat +
                                        "&rol=" + rol +
                                        "&codNivel=" + codNivel +
                                        "&desNivel=" + desNivel +
                                        "&codSede=" + codSede +
                                        "&desSede=" + desSede +
                                        "&codGrado=" + codGrado +
                                        "&desGrado=" + desGrado +
                                        "&conUser=" + conUser,
                                success: function (data) {
                                    $.ajax({
                                        type: 'POST',
                                        url: "../UsuarioServlet?accion=validarUsuario",
                                        data: "correo=" + correo,
                                        success: function (result) {
                                            if (data == 1) {
                                                swal({
                                                    title: "Usuario correctamente Registrado",
                                                    confirmButtonColor: "#66BB6A",
                                                    type: "success"
                                                });
                                                $("#modal_theme_primary").modal("hide");
                                                document.getElementById("formAgregar").reset();
                                                $("#tblUsuario").DataTable().destroy();
                                                datosUsuario.listarUsuario();
                                                validarCombos();
                                            } else if (result != 0) {
                                                if (rol == 'ESTUDIANTE' || rol == 'DOCENTE') {
                                                    swal({
                                                        title: "DNI Repetido",
                                                        text: "Ingresa un DNI válido",
                                                        confirmButtonColor: "#66BB6A",
                                                        type: "warning"
                                                    });
                                                    $('#txtDni').val("");
                                                    $('#txtDni').focus();
                                                } else if (rol == 'DIRECTOR PRIMARIA' || rol == 'DIRECTOR SECUNDARIA') {
                                                    swal({
                                                        title: "Correo Repetido",
                                                        text: "Ingresa un correo válido",
                                                        confirmButtonColor: "#66BB6A",
                                                        type: "warning"
                                                    });
                                                    $('#txtCorreo').val("");
                                                    $('#txtCorreo').focus();
                                                }

                                            }
                                        }
                                    });
                                }
                            });
                        }
                    });
        }
    });
}
